#include <iostream>

using namespace std;

int main()
{
    int n,x;
    cin>>n;
    for (int i=0;i<n;i++)
    {
        string x;
        cin>>x;
    }
    int r[n][n];
    for (int i=0;i<n;i++)
        for (int j=0;j<n;j++)
        {
            cin>>x;
            if (i>0&&j>0)
                r[i][j]=min(r[i-1][j],r[i][j-1])+x;
            else if (i>0)
                r[i][j]=r[i-1][j]+x;
            else if (j>0)
                r[i][j]=r[i][j-1]+x;
            else
                r[i][j]=x;

        }
    cout<<r[n-1][n-1];
}